#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <cstrike>


#define WEAPON_INDEX_C4 4
#define ZERO_MONEY 0

#define WEAPONNUM 2

#define AMP_SHAKE        50.0
#define DUR_SHAKE        1.0

#define PLUGIN_VERSION "2.4"


new Handle:css_avp_damage ;
new Handle:css_avp_radius ;
new Handle:css_avp_pushforce ;
new Handle:cvDelay = INVALID_HANDLE;
new Handle:cvType = INVALID_HANDLE;

new Handle:Cvar_Enable;
new Handle:Cvar_PredatorCount;
new Handle:Cvar_RespawnTime = INVALID_HANDLE;
new Handle:Cvar_run_Predator;
new Handle:Cvar_run_Alien;
new Handle:Cvar_HP_Predator = INVALID_HANDLE;
new Handle:Cvar_HP_Alien = INVALID_HANDLE;
new Handle:Cvar_SpawnAlienQueen = INVALID_HANDLE;
new Handle:Cvar_run_AlienQueen;
new Handle:Cvar_HP_AlienQueen = INVALID_HANDLE;
new String:Weapon[WEAPONNUM][] = {"","weapon_knife"};

new Handle:g_cvJumpBoostPreda = INVALID_HANDLE;
new Handle:g_cvJumpMaxPreda = INVALID_HANDLE;
new Handle:g_cvJumpBoostAlien = INVALID_HANDLE;
new Handle:g_cvJumpMaxAlien = INVALID_HANDLE;
new Float:g_flBoostPreda = 250.0;
new Float:g_flBoostAlien = 250.0;
new g_fLastButtons[MAXPLAYERS+1];
new g_fLastFlags[MAXPLAYERS+1];
new g_iJumps[MAXPLAYERS+1];
new g_iJumpMaxPreda;
new g_iJumpMaxAlien;

new	alienqueen;
new g_weaponHasOwner;
new m_iFOV;
new g_iAccount = -1;


public Plugin:myinfo = 
{
	name = "CSS PREDATORMOD",
	author = "Andi67",
	description = "Predatormod for AVP",
	version = PLUGIN_VERSION,
	url = "http://dodsourceplugins.net"
};

public OnPluginStart()
{
	CreateConVar("css_avp_version", PLUGIN_VERSION, "CSS AVP Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);


	Cvar_Enable = CreateConVar("css_avp_predatormod_enable", "1", "Enable/disable CSS AVP PredatoR Mod", FCVAR_PLUGIN);
	Cvar_PredatorCount = CreateConVar( "css_avp_predatorcount", "6", "2 = 1 Predator , 3 = 2 Predators ect.", FCVAR_PLUGIN);
	Cvar_run_Predator= CreateConVar("css_avp_predator_speed", "1.3", "Sprint speed Predator.", FCVAR_PLUGIN);
	Cvar_run_Alien= CreateConVar("css_avp_alien_speed", "1.5", "Sprint speed Alien.", FCVAR_PLUGIN);
	Cvar_HP_Predator = CreateConVar("css_avp_predator_hp", "300", " Set Predator HP at Spawn", FCVAR_PLUGIN);
	Cvar_HP_Alien = CreateConVar("css_avp_alien_hp", "120", " Set Alien HP at Spawn", FCVAR_PLUGIN);
	Cvar_RespawnTime = CreateConVar("css_avp_respawntime", "3.0", " Time to wait for respawn", FCVAR_PLUGIN);
	Cvar_SpawnAlienQueen = CreateConVar("css_avp_alienqueen_spawntime", "45.0", " Remaining Time when AlienQueen spawns", FCVAR_PLUGIN);
	Cvar_run_AlienQueen= CreateConVar("css_avp_alienqueen_speed", "1.8", "Sprint speed for Alienqueen.", FCVAR_PLUGIN);
	Cvar_HP_AlienQueen = CreateConVar("css_avp_alienqueen_hp", "450", " HP for Alienqueen", FCVAR_PLUGIN);	
	
	css_avp_damage = 	CreateConVar("css_avp_alienqueen_damage", "50", "Damage done by Alienqueenspit", FCVAR_PLUGIN);
	css_avp_radius = CreateConVar("css_avp_alienqueen_radius", "100", "Radius of start", FCVAR_PLUGIN);	
	css_avp_pushforce =  CreateConVar("css_avp_alienqueen_pushforce", "1000", "Pushforce of Alienqueenblast", FCVAR_PLUGIN);	
	
	cvDelay = CreateConVar("css_avp_dissolve_delay","0.1");
	cvType = CreateConVar("css_avp_dissolve_type", "0");	
	
	g_cvJumpBoostPreda = CreateConVar("css_avp_jump_boost_predator", "250.0","The amount of vertical boost to apply to  jumps for predas.",FCVAR_PLUGIN);
	g_cvJumpMaxPreda = CreateConVar("css_avp_jump_max_predator", "2","The maximum number of re-jumps allowed while already jumping for predas.",FCVAR_PLUGIN);
	g_cvJumpBoostAlien = CreateConVar("css_avp_jump_boost_alien", "250.0","The amount of vertical boost to apply to  jumps for aliens.",FCVAR_PLUGIN);
	g_cvJumpMaxAlien = CreateConVar("css_avp_jump_max_alien", "3","The maximum number of re-jumps allowed while already jumping for aliens.",FCVAR_PLUGIN);
	
	AutoExecConfig(true,"css_avp_predatormod", "css_avp_predatormod");		
	
	m_iFOV = FindSendPropOffs("CBasePlayer","m_iFOV");
	g_iAccount = FindSendPropOffs("CCSPlayer", "m_iAccount");
	g_weaponHasOwner = FindSendPropOffs("CBaseCombatWeapon", "m_hOwnerEntity");	
	
	HookConVarChange(g_cvJumpBoostPreda,convar_ChangeBoostPreda);
	HookConVarChange(g_cvJumpMaxPreda,convar_ChangeMaxPreda);
	HookConVarChange(g_cvJumpBoostAlien,convar_ChangeBoostAlien);
	HookConVarChange(g_cvJumpMaxAlien,convar_ChangeMaxAlien);	
	
	g_flBoostPreda = GetConVarFloat(g_cvJumpBoostPreda);
	g_iJumpMaxPreda = GetConVarInt(g_cvJumpMaxPreda);
	g_flBoostAlien = GetConVarFloat(g_cvJumpBoostAlien);
	g_iJumpMaxAlien = GetConVarInt(g_cvJumpMaxAlien);	
	
	HookEvent("player_spawn", PlayerSpawnEvent);
	HookEvent("player_hurt", PlayerHurtEvent);
	HookEvent("player_team", PlayerTeamEvent);
	HookEvent("player_death", PlayerDeathEvent);
	HookEvent("round_start", Event_RoundStart);
	HookEvent("round_end" , Event_RoundEnd);
	HookEvent( "player_disconnect",	Event_PlayerDisconnect,	EventHookMode_Pre);
	
	CreateTimer(GetConVarFloat(Cvar_SpawnAlienQueen), EnableAlienRage  ,_, TIMER_REPEAT);	

	PrintToServer("----------------|         CSS_AVP_PredatoR Loaded         |---------------")
}

public OnEventShutdown()
{
	UnhookEvent("player_spawn", PlayerSpawnEvent);
	UnhookEvent("player_hurt", PlayerHurtEvent);
	UnhookEvent("player_spawn", PlayerTeamEvent);
	UnhookEvent("player_hurt", PlayerDeathEvent);
	UnhookEvent( "player_disconnect",Event_PlayerDisconnect);
	UnhookEvent("round_start", Event_RoundStart);
	UnhookEvent("round_end" , Event_RoundEnd);
}

public OnMapStart()
{
	AddFileToDownloadsTable("sound/predator/imhere.mp3");	
	AddFileToDownloadsTable("sound/predator/hurt/pain_1.wav");
	AddFileToDownloadsTable("sound/alien/hurt/pain_1.wav");
	AddFileToDownloadsTable("sound/alien/dead/death_2.wav");
	AddFileToDownloadsTable("sound/predator/dead/spot_0.wav");
	AddFileToDownloadsTable("sound/queen/spawn/spot_1.wav");
	PrecacheSound("queen/spawn/spot_1.wav", true);	
	PrecacheSound("predator/dead/spot_0.wav", true);	
	PrecacheSound("predator/hurt/pain_1.wav", true);
	PrecacheSound("alien/hurt/pain_1.wav", true);
	PrecacheSound("alien/dead/death_2.wav", true);
	PrecacheSound("predator/imhere.mp3", true);	

	PrecacheModel("models/player/slow/aliendrone_v3/slow_alien.mdl");
	PrecacheModel("models/player/techknow/predator_v2/predator.mdl");
	PrecacheModel("models/player/avp/alienqueen.mdl");

	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_arms.vmt");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_arms.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_arms_normal.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_head.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_head.vmt");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_head_normal.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_legs.vmt");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_legs.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_legs_normal.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_torso.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_torso.vmt");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/drone_torso_normal.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/slow_alien_schwanz.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/slow_alien_schwanz.vmt");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/slow_alien_gebiss.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/slow_alien_gebiss.vmt");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/slow_alien_blood.vtf");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/slow_alien_blood.vmt");
	AddFileToDownloadsTable("materials/models/player/slow/aliendrone_v3/slow_alien_gebiss_bump.vtf");
	AddFileToDownloadsTable("models/player/slow/aliendrone_v3/slow_alien.dx80.vtx");
	AddFileToDownloadsTable("models/player/slow/aliendrone_v3/slow_alien.dx90.vtx");
	AddFileToDownloadsTable("models/player/slow/aliendrone_v3/slow_alien.mdl");
	AddFileToDownloadsTable("models/player/slow/aliendrone_v3/slow_alien.phy");
	AddFileToDownloadsTable("models/player/slow/aliendrone_v3/slow_alien.sw.vtx");
	AddFileToDownloadsTable("models/player/slow/aliendrone_v3/slow_alien.vvd");

	AddFileToDownloadsTable("materials/models/player/techknow/predator/chest.vmt");
	AddFileToDownloadsTable("materials/models/player/techknow/predator/chest.vtf");
	AddFileToDownloadsTable("materials/models/player/techknow/predator/chest_n.vtf");
	AddFileToDownloadsTable("materials/models/player/techknow/predator/crop.vtf");
	AddFileToDownloadsTable("materials/models/player/techknow/predator/crop.vmt");
	AddFileToDownloadsTable("materials/models/player/techknow/predator/crop_n.vtf");
	AddFileToDownloadsTable("materials/models/player/techknow/predator/head.vmt");
	AddFileToDownloadsTable("materials/models/player/techknow/predator/head.vtf");
	AddFileToDownloadsTable("materials/models/player/techknow/predator/head_n.vtf");
	AddFileToDownloadsTable("models/player/techknow/predator_v2/predator.dx80.vtx");
	AddFileToDownloadsTable("models/player/techknow/predator_v2/predator.dx90.vtx");
	AddFileToDownloadsTable("models/player/techknow/predator_v2/predator.mdl");
	AddFileToDownloadsTable("models/player/techknow/predator_v2/predator.phy");
	AddFileToDownloadsTable("models/player/techknow/predator_v2/predator.sw.vtx");
	AddFileToDownloadsTable("models/player/techknow/predator_v2/predator.vvd");
	
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/torso.vmt");
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/torso.vtf");
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/torso_n.vtf");
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/legs.vtf");
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/legs.vmt");
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/legs_n.vtf");
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/head.vmt");
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/head.vtf");
	AddFileToDownloadsTable("materials/models/player/avp/alienqueen/head_n.vtf");
	AddFileToDownloadsTable("models/player/avp/alienqueen.dx80.vtx");
	AddFileToDownloadsTable("models/player/avp/alienqueen.dx90.vtx");
	AddFileToDownloadsTable("models/player/avp/alienqueen.mdl");
	AddFileToDownloadsTable("models/player/avp/alienqueen.phy");
	AddFileToDownloadsTable("models/player/avp/alienqueen.sw.vtx");
	AddFileToDownloadsTable("models/player/avp/alienqueen.vvd");	
}

public convar_ChangeBoostPreda(Handle:convar, const String:oldVal[], const String:newVal[]) 
{
	g_flBoostPreda = StringToFloat(newVal);
}

public convar_ChangeMaxPreda(Handle:convar, const String:oldVal[], const String:newVal[])
{
	g_iJumpMaxPreda = StringToInt(newVal);
}

public convar_ChangeBoostAlien(Handle:convar, const String:oldVal[], const String:newVal[]) 
{
	g_flBoostAlien = StringToFloat(newVal);
}

public convar_ChangeMaxAlien(Handle:convar, const String:oldVal[], const String:newVal[])
{
	g_iJumpMaxAlien = StringToInt(newVal);
}

public OnClientPostAdminCheck(client)
{
	if (IsValidClient(client))
	{
		CreateTimer(5.0 , WelcomeMessage , client);
		SDKHook(client, SDKHook_WeaponDrop, OnWeaponDrop);
	}
}


//  Events
public Action:Event_RoundStart(Handle:event, const String:name[], bool:dontBrodcast)
{
    for (new i = 1; i <= MaxClients; i++)
    {
        if (IsValidClient(i))
        {
			SetEntProp(i, Prop_Data, "m_takedamage", 2, 1);
		
			new iWeapon = GetPlayerWeaponSlot(i, 4);
			
			if (iWeapon != -1 && IsValidEdict(iWeapon))
			{
				decl String:szClassName[64];
				GetEdictClassname(iWeapon, szClassName, sizeof(szClassName));
				
				if (StrEqual(szClassName, "weapon_c4"))
				{
					RemovePlayerItem(i, iWeapon);
					RemoveEdict(iWeapon);
				}
			}
		}
	}
}

public Action:Event_RoundEnd(Handle:event, const String:name[], bool:dontBrodcast)
{
    for (new i = 1; i <= MaxClients; i++)
    {
        if (IsValidClient(i))
        {
			SetEntProp(i, Prop_Data, "m_takedamage", 0, 1);
		}
	}
}

public PlayerSpawnEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	
	if (GetClientTeam(client) == 3)
	{
		if( GetTeamClientCount(3) > GetConVarInt( Cvar_PredatorCount ))
		{		
			CS_SwitchTeam( client, 2 );
		}
		
		if (GetConVarInt(Cvar_Enable) == 1)
		{
			SetEntityModel(client,"models/player/techknow/predator_v2/predator.mdl");
			SetEntityRenderMode(client,  RENDER_TRANSCOLOR);
			SetEntityRenderColor(client, 100, 100, 100, 100);
			SetEntityHealth(client, GetConVarInt(Cvar_HP_Predator));
			EmitSoundToClient(client, "predator/imhere.mp3");
			SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", GetConVarFloat(Cvar_run_Predator));	
			PrintToChat(client,"PREDATOR INVISIBILITY : ON");
		}
		for(new i = 0; i < 4; i++)
		{
			new weapon = GetPlayerWeaponSlot(client, i);
			if(weapon != -1)
			{
				SetEntityRenderMode(weapon,  RENDER_TRANSCOLOR);
				SetEntityRenderColor(weapon, 100, 100, 100, 100);
			}
		}
	}
	else if (GetClientTeam(client) == 2 && IsValidClient(client))
	{
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", GetConVarFloat(Cvar_run_Alien));
		SetEntData(client, g_iAccount, ZERO_MONEY);
		CreateTimer(0.1, RemoveWeapons, client);
		CreateTimer(0.2, GiveWeapons,client);
		Alien_Vision(client);
		SetEntityModel(client,"models/player/slow/aliendrone_v3/slow_alien.mdl");
		SetEntityRenderColor(client, 255, 255, 255, 255);
		SetEntityHealth(client, GetConVarInt(Cvar_HP_Alien));
	}
}

public PlayerHurtEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"))
	
	if (GetConVarInt(Cvar_Enable) == 1)
	{
		decl Float:vecOrigin[3];
		GetClientAbsOrigin(client, vecOrigin);
		
		if (GetClientTeam(client) == 3 && GetClientHealth(client)< 200)
		{
			SetEntityRenderColor(client, 255, 255, 255, 255);
			PrintToChat(client,"PREDATOR INVISIBILITY : OFF");
			
			EmitAmbientSound("predator/hurt/pain_1.wav", vecOrigin, client, _, _, 1.0);
			Shake(client, AMP_SHAKE, DUR_SHAKE);
			
			for(new i = 0; i < 4; i++)
			{			
				new weapon = GetPlayerWeaponSlot(client, i);
				if(weapon != -1)
				{
					SetEntityRenderMode(weapon,  RENDER_TRANSCOLOR);
					SetEntityRenderColor(weapon, 255, 255, 255, 255);
				}
			}
		}
		if (GetClientTeam(client) == 2)
		{
			EmitAmbientSound("alien/hurt/pain_1.wav", vecOrigin, client, _, _, 1.0);
			Shake(client, AMP_SHAKE, DUR_SHAKE);
		}
	}
}

public PlayerDeathEvent(Handle:event, const String:name[], bool:dontBroadcast)
{	
	new	victim   = GetClientOfUserId(GetEventInt(event,"userid"));
	new attacker = GetClientOfUserId(GetEventInt(event,"attacker"));
	
	decl Float:vecOrigin[3];
	GetClientAbsOrigin(victim, vecOrigin);	
	
	if(IsValidClient(victim) && GetClientTeam(victim) == 2)
	{
		EmitAmbientSound("alien/dead/death_2.wav", vecOrigin, victim, _, _, 1.0);		
	}
	
	else if(GetClientTeam(victim) == 3)
	{
		EmitAmbientSound("predator/dead/spot_0.wav" , vecOrigin, victim, _, _, 1.0);
	}
	
	if(IsValidClient(victim) && GetClientTeam(victim) == 3 && IsValidClient(attacker) && attacker != alienqueen)
	{
		new Handle:dp;
		CreateDataTimer( 1.0, Timer_ChangeTeams, dp );
		WritePackCell(dp, attacker);
		WritePackCell(dp, victim);	
	}
	CreateTimer(GetConVarFloat(Cvar_RespawnTime) ,RespawnPlayer , victim);
	Death(victim);
}

public Action:Event_PlayerDisconnect(Handle:event, const String:name[], bool:dontBroadcast)
{	
	if( GetTeamClientCount(3) <= GetConVarInt(Cvar_PredatorCount))
	{
		for( new i = 1; i <= MaxClients; i++ )
		{
			if( IsClientInGame(i) && GetClientTeam(i) == 2)
			{
				CS_SwitchTeam( i, 3 );			
				PrintToChat( i, "You are now Predator, the old one fled!" );
				break;
			}
		}
	}
	return Plugin_Continue;
}

public PlayerTeamEvent( Handle:event, const String:name[], bool:dontBroadcast )
{	
	CreateTimer( 1.0, Timer_CheckTeams );
	alienqueen = 0;
}


//  Timers
public Action:RemoveWeapons(Handle:timer, any:client)
{
	for(new i = 0; i < 4; i++)
	{
		new weapon = GetPlayerWeaponSlot(client, i);
		if(weapon != -1)
		{
			RemovePlayerItem(client, weapon);
			RemoveEdict(weapon);
		}
	}
}

public Action:GiveWeapons(Handle:timer, any:client)
{
	GivePlayerItem(client, Weapon[1]);
	
	new weaponent = GetPlayerWeaponSlot(client, 2);
	
	SetEntityRenderMode(weaponent,  RENDER_TRANSCOLOR);
	SetEntityRenderColor(weaponent, 0, 0, 0, 0);
}



public Action:RespawnPlayer( Handle:timer , any:client )
{
	if(IsValidClient(client))
	{
		CS_RespawnPlayer(client);
	}
}

public Action:WelcomeMessage(Handle:timer, any:client)
{
	if(IsValidClient(client))
	{	
		PrintCenterText(client , "Welcome Mate , this Server is running Predatormod!!!");
	}
}

public Action:EnableAlienRage(Handle:timer)
{
	alienqueen = GetRandomPlayer(2);

	if(IsValidClient(alienqueen))
	{
		new String:SzName[64];
		GetClientName(alienqueen, SzName, sizeof(SzName));
			
		PrintHintTextToAll("%s has become AlienQueen \n and is really pissed of \n for killing so much Aliens!!!", SzName);
		SetEntityModel(alienqueen,"models/player/avp/alienqueen.mdl");
		SetEntityHealth(alienqueen, GetConVarInt(Cvar_HP_AlienQueen));
		EmitSoundToAll("queen/spawn/spot_1.wav");
		SetEntPropFloat(alienqueen, Prop_Data, "m_flLaggedMovementValue", GetConVarFloat(Cvar_run_AlienQueen));
	}
}

public Action:Timer_CheckTeams( Handle:timer )
{
	for( new i = 1; i <= MaxClients; i++ )
	{
		if(IsValidClient(i) && GetTeamClientCount(3) >= GetConVarInt(Cvar_PredatorCount))
		{
			PrintCenterText( i, "You are not the Predator, stick with T please" );
			CS_SwitchTeam( i, 2 );
		}
		if(IsValidClient(i) && GetTeamClientCount(2) == GetConVarInt(Cvar_PredatorCount))
		{
			PrintCenterText( i, "You are the Predator, stick with CT please" );
			CS_SwitchTeam( i, 3 );
		}
	}
	return Plugin_Stop;
}

public Action:Timer_ChangeTeams(Handle:timer, Handle:dp)
{
	// Switch players
	ResetPack(dp);
	new attacker = ReadPackCell(dp);
	new victim   = ReadPackCell(dp);
	
	CS_SwitchTeam( attacker, 3);
	CS_SwitchTeam( victim,   2);
}

public Action:RemoveParticle(Handle:timer, any:particle)
{
	if(IsValidEdict(particle))
	{
		AcceptEntityInput(particle, "Kill");
		RemoveEdict(particle);
	}
}

public Action:DeletePushForce(Handle:timer, any:ent)
{
	if (IsValidEntity(ent))
	{
		decl String:classname[64];
		GetEdictClassname(ent, classname, sizeof(classname));
		if (StrEqual(classname, "point_push", false))
		{
			AcceptEntityInput(ent, "Disable");
			AcceptEntityInput(ent, "Kill"); 
			RemoveEdict(ent);
		}
	}
}

public Action:DeletePointHurt(Handle:timer, any:ent)
{
	if (IsValidEntity(ent))
	{
		decl String:classname[64];
		GetEdictClassname(ent, classname, sizeof(classname));
		if (StrEqual(classname, "point_hurt", false))
		{
			AcceptEntityInput(ent, "Kill"); 
			RemoveEdict(ent);
		}
	}
}

public Action:DissolveRagdoll(Handle:timer, any:client)
{
	if (!IsValidEntity(client))
    return;

	new ragdoll = GetEntPropEnt(client, Prop_Send, "m_hRagdoll");
	if (ragdoll<0)
	{
		PrintToServer("[DISSOLVE] Could not get ragdoll for player!");  
		return;
	}
    
	new String:dname[32], String:dtype[32];
	Format(dname, sizeof(dname), "dis_%d", client);
	Format(dtype, sizeof(dtype), "%d", GetConVarInt(cvType));
  
	new ent = CreateEntityByName("env_entity_dissolver");
	if (ent>0)
	{
		DispatchKeyValue(ragdoll, "targetname", dname);
		DispatchKeyValue(ent, "dissolvetype", dtype);
		DispatchKeyValue(ent, "target", dname);
		AcceptEntityInput(ent, "Dissolve");
		AcceptEntityInput(ent, "kill");
	}	
}

public Action:DeleteDroppedWeapon(Handle:timer, any:weapon)
{
	new maxent = GetMaxEntities(), String:name[64];
	for (new i=GetMaxClients();i<maxent;i++)
	{
		if ( IsValidEdict(i) && IsValidEntity(i) )
		{
			GetEdictClassname(i, name, sizeof(name));
			if ( ( StrContains(name, "weapon_") != -1 || StrContains(name, "item_") != -1 ) && GetEntDataEnt2(i, g_weaponHasOwner) == -1 )
					RemoveEdict(i);
		}
	}
}

// Functions & Stocks
public Action:OnWeaponDrop(client, weapon)
{
    if (weapon && IsValidEdict(weapon) && IsValidEntity(weapon))
            CreateTimer(0.01, DeleteDroppedWeapon, weapon);

    return Plugin_Continue;
}

Death(client)
{
	new Float:delay = GetConVarFloat(cvDelay);
	if (delay>0.0)
	{
		CreateTimer(delay, DissolveRagdoll, client); 
	}
	else
	{
		DissolveRagdoll(INVALID_HANDLE, client);
	}	
}

GetRandomPlayer(team)
{
	new clients[MaxClients+1], clientCount;
	for (new i = 1; i <= MaxClients; i++)
		if (IsClientInGame(i) && (GetClientTeam(i) == team))
		clients[clientCount++] = i;
	return (clientCount == 0) ? -1 : clients[GetRandomInt(0, clientCount-1)];
} 

public IsValidClient( client ) 
{ 
    if ( !( 1 <= client <= MaxClients ) || !IsClientInGame(client) ) 
        return false; 
     
    return true; 
}

stock Alien_Vision(const any:client)
{
	new Handle:message = StartMessageOne("Fade", client, 1);
	
	if(IsClientInGame(client) && IsClientConnected(client) && IsPlayerAlive(client))
	{
		//FFADE_IN            0x0001        // Just here so we don't pass 0 into the function
		//FFADE_OUT           0x0002        // Fade out (not in)
		//FFADE_MODULATE      0x0004        // Modulate (don't blend)
		//FFADE_STAYOUT       0x0008        // ignores the duration, stays faded out until new ScreenFade message received
		//FFADE_PURGE         0x0010        // Purges all other fades, replacing them with this one
		
		
		SetEntData(client, m_iFOV, 120, 4, true);
		BfWriteShort(message, 585);
		BfWriteShort(message, 585);
		BfWriteShort(message, (0x0008)); //Fade out
		BfWriteByte(message, 0); //fade red
		BfWriteByte(message, 200); //fade green
		BfWriteByte(message, 0); //fade blue
		BfWriteByte(message, 25); //fade alpha
		EndMessage();
	}
}

stock Shake(client, Float:flAmplitude, Float:flDuration)
{
    new Handle:hBf=StartMessageOne("Shake", client);
    if(hBf!=INVALID_HANDLE)
    
    BfWriteByte(hBf,  0);
    BfWriteFloat(hBf, flAmplitude);
    BfWriteFloat(hBf, 1.0);
    BfWriteFloat(hBf, flDuration);
    EndMessage();
}


//  Things to do on Gameframe & RunCmd
public OnGameFrame() 
{
	for (new i = 1; i <= MaxClients; i++) 
	{
		if(IsClientInGame(i) && IsPlayerAlive(i)) 
		{
			DoubleJump(i)
		}
	}
	if(IsValidClient(alienqueen) && GetClientButtons(alienqueen)  & IN_ATTACK2)
	{
		SpitEffect(alienqueen);
	}	
}

//public Action:OnPlayerRunCmd(iClient, &iButtons, &Impulse, Float:fVelocity[3], Float:fAngles[3], &iWeapon)
//{
//	if(IsValidClient(alienqueen) && iButtons  & IN_ATTACK)
//	{
//		SpitEffect(alienqueen);
//	}
//}


//  Jumps , Entity , Traces
stock DoubleJump(const any:client) 
{
	new fCurFlags	= GetEntityFlags(client);
	new fCurButtons	= GetClientButtons(client);
	
	if (g_fLastFlags[client] & FL_ONGROUND) 
	{
		if (!(fCurFlags & FL_ONGROUND) && !(g_fLastButtons[client] & IN_JUMP) && fCurButtons & IN_JUMP) 
		{
			OriginalJump(client);
		}
	} 
	else if (fCurFlags & FL_ONGROUND) 
	{
		Landed(client);
	} 
	else if (!(g_fLastButtons[client] & IN_JUMP) &&	fCurButtons & IN_JUMP) 
	{
		ReJump(client);
	}
	
	g_fLastFlags[client] = fCurFlags;
	g_fLastButtons[client] = fCurButtons;
}

stock OriginalJump(const any:client) 
{
	g_iJumps[client]++;
}

stock Landed(const any:client) 
{
	g_iJumps[client] = 0;
}

stock ReJump(const any:client) 
{
	if ( 1 <= g_iJumps[client] <= g_iJumpMaxPreda && GetClientTeam(client) == 3) 
	{
		g_iJumps[client]++;
		decl Float:vVel[3];
		GetEntPropVector(client, Prop_Data, "m_vecVelocity", vVel);
		
		vVel[2] = g_flBoostPreda;
		TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, vVel);
	}
	if ( 1 <= g_iJumps[client] <= g_iJumpMaxAlien && GetClientTeam(client) == 2) 
	{
		g_iJumps[client]++;
		decl Float:vVel[3];
		GetEntPropVector(client, Prop_Data, "m_vecVelocity", vVel);
		
		vVel[2] = g_flBoostAlien;
		TeleportEntity(client, NULL_VECTOR, NULL_VECTOR, vVel);
	}	
}

stock SpitEffect(const any:client)
{	
	if (IsValidClient(client))
	{								
		new Float:vAngles[3];
		new Float:vOrigin[3];

						
		GetClientEyePosition(client, vOrigin);
		GetClientEyeAngles(client, vAngles);
		
		new particle = CreateEntityByName("env_smokestack");
		if(IsValidEdict(particle))
		{
			decl String:Name[32]; 
			Format(Name, sizeof(Name), "laser_%i", particle);
			DispatchKeyValue(particle, "targetname", Name);
			DispatchKeyValue(particle, "parentname", Name);
			DispatchKeyValueFloat(particle, "BaseSpread", 1.0);
			DispatchKeyValueFloat(particle, "StartSize", 1.0);
			DispatchKeyValueFloat(particle, "EndSize", 10.0);
			DispatchKeyValueFloat(particle, "Twist", 0.0);
			DispatchKeyValue(particle, "Name", Name);
			DispatchKeyValue(particle, "SmokeMaterial", "particle/fire.vmt");
			DispatchKeyValue(particle, "RenderColor", "0 255 80");
			DispatchKeyValue(particle, "SpreadSpeed", "30");
			DispatchKeyValue(particle, "RenderAmt", "50");
			DispatchKeyValue(particle, "JetLength", "400");
			DispatchKeyValue(particle, "Speed", "350");
			DispatchKeyValue(particle, "Rate", "500");
			DispatchSpawn(particle);
			TeleportEntity(particle, vOrigin, vAngles, NULL_VECTOR);
			
			SetVariantString("!activator");
			AcceptEntityInput(particle, "SetParent", client, particle, 0);
			SetVariantString("head");
			AcceptEntityInput(particle, "SetParentAttachment", client, client, 0);
			AcceptEntityInput(particle, "TurnOn");
			CreateTimer(2.0, RemoveParticle, particle);
			
			TraceHitPlayer(client);
		}
	}
}


public bool:TraceEntityFilterPlayer(entity, contentsMask, any:data)
{
	return data != entity;
}

public Action:TraceHitPlayer(any:client)
{
	new Float:vAngles[3], Float:vOrigin[3], Float:AnglesVec[3], Float:EndPoint[3], Float:pos[3];

	new Float:Distance = 600.0;
	GetClientEyeAngles(client,vAngles);
	GetClientEyePosition(client,vOrigin);
	GetAngleVectors(vAngles, AnglesVec, NULL_VECTOR, NULL_VECTOR);
	
	EndPoint[0] = vOrigin[0] + (AnglesVec[0]*Distance);
	EndPoint[1] = vOrigin[1] + (AnglesVec[1]*Distance);
	EndPoint[2] = vOrigin[2] + (AnglesVec[2]*Distance);
	
	new Handle:trace = TR_TraceRayFilterEx(vOrigin, EndPoint, MASK_SHOT, RayType_EndPoint, TraceEntityFilterPlayer, client);

	if (TR_DidHit(trace))
	{
		new TargetHit = TR_GetEntityIndex(trace);
		
		if ((TargetHit > 0) && (TargetHit <= GetMaxClients()))
		{
			new String:name[64];
			GetClientName(TargetHit, name, sizeof(name));
			
			if (GetClientTeam(TargetHit) == 3)
			{		
				GetEntityAbsOrigin2(TargetHit,EndPoint);
				
				new Float:damage=GetConVarFloat(css_avp_damage);
				new Float:radius=GetConVarFloat(css_avp_radius);
				new Float:pushforce=GetConVarFloat(css_avp_pushforce);
		
				new pointHurt = CreateEntityByName("point_hurt");   
 	
				DispatchKeyValueFloat(pointHurt, "Damage", damage);        
				DispatchKeyValueFloat(pointHurt, "DamageRadius", radius);     
				DispatchKeyValue(pointHurt, "DamageDelay", "0.0");   
				DispatchSpawn(pointHurt);
				TeleportEntity(pointHurt, EndPoint, NULL_VECTOR, NULL_VECTOR);  
				AcceptEntityInput(pointHurt, "Hurt", -1);    
				CreateTimer(0.1, DeletePointHurt, pointHurt); 
	
		
				new push = CreateEntityByName("point_push");         
				DispatchKeyValueFloat (push, "magnitude", pushforce);                     
				DispatchKeyValueFloat (push, "radius", radius*1.0);                     
				SetVariantString("spawnflags 24");                     
				AcceptEntityInput(push, "AddOutput");
				DispatchSpawn(push);   
				TeleportEntity(push, EndPoint, NULL_VECTOR, NULL_VECTOR);  
				AcceptEntityInput(push, "Enable", -1, -1);
				CreateTimer(0.5, DeletePushForce, push);
			}
		}
	}

	TR_GetEndPosition(pos, trace);
	//draw your beam
	
	CloseHandle(trace);
}

GetEntityAbsOrigin2(TargetHit,Float:EndPoint[3]) 
{
	decl Float:mins[3], Float:maxs[3];
	
	GetEntPropVector(TargetHit,Prop_Send,"m_vecOrigin",EndPoint);
	GetEntPropVector(TargetHit,Prop_Send,"m_vecMins",mins);
	GetEntPropVector(TargetHit,Prop_Send,"m_vecMaxs",maxs);
	
	EndPoint[0] += (mins[0] + maxs[0]) * 0.5;
	EndPoint[1] += (mins[1] + maxs[1]) * 0.5;
	EndPoint[2] += (mins[2] + maxs[2]) * 0.5;
}